diff -BbuprN tbamud-3.55/lib/world/qst/index tbamud-3.55+quests/lib/world/qst/index
--- tbamud-3.55/lib/world/qst/index	1970-01-01 00:00:00.000000000 +0000
+++ tbamud-3.55+quests/lib/world/qst/index	2008-01-31 12:53:46.710047000 +0000
@@ -0,0 +1 @@
+$
diff -BbuprN tbamud-3.55/src/Makefile.amiga tbamud-3.55+quests/src/Makefile.amiga
--- tbamud-3.55/src/Makefile.amiga	2008-01-16 23:21:14.000000000 +0000
+++ tbamud-3.55+quests/src/Makefile.amiga	2008-01-31 09:56:06.147547000 +0000
@@ -192,3 +192,12 @@ utils.o: utils.c conf.h sysdep.h structs
 weather.o: weather.c conf.h sysdep.h structs.h utils.h comm.h handler.h \
   interpreter.h db.h
 	$(CC) -c $(CFLAGS) weather.c
+quest.o: quest.c conf.h sysdep.h structs.h utils.h interpreter.h handler.h \
+  comm.h db.h screen.h quest.h
+	$(CC) -c $(CFLAGS) quest.c
+qedit.o: qedit.c conf.h sysdep.h structs.h utils.h comm.h db.h oasis.h \
+  improved-edit.h screen.h genolc.h genzon.h interpreter.h quest.h
+	$(CC) -c $(CFLAGS) qedit.c
+genqst.o: genqst.c conf.h sysdep.h structs.h utils.h db.h quest.h \
+  genolc.h genzon.h 
+	$(CC) -c $(CFLAGS) genqst.c
diff -BbuprN tbamud-3.55/src/Makefile.bcc tbamud-3.55+quests/src/Makefile.bcc
--- tbamud-3.55/src/Makefile.bcc	2008-01-16 23:21:14.000000000 +0000
+++ tbamud-3.55+quests/src/Makefile.bcc	2008-01-31 09:59:18.553797000 +0000
@@ -78,7 +78,10 @@ Dep_circledexe = \
    spec_procs.obj\
    spec_assign.obj\
    utils.obj\
-   weather.obj
+   weather.obj\
+   quest.obj\
+   qedit.obj\
+   genqst.obj
 
 circle.exe : $(Dep_circledexe)
   $(TLINK32) @&&|
@@ -119,7 +122,10 @@ spell_parser.obj+
 spec_procs.obj+
 spec_assign.obj+
 utils.obj+
-weather.obj
+weather.obj+
+quest.obj+
+qedit.obj+
+genqst.obj
 $<,$*
 C:\BC5\LIB\bidsfi.lib+
 C:\BC5\LIB\import32.lib+
@@ -306,6 +312,21 @@ weather.obj :  weather.c
  $(CompOptsAt_circledexe) $(CompInheritOptsAt_circledexe) -o$@ weather.c
 |
 
+quest.obj :  quest.c
+  $(BCC32) -P- -c @&&|
+ $(CompOptsAt_circledexe) $(CompInheritOptsAt_circledexe) -o$@ quest.c
+|
+
+qedit.obj :  qedit.c
+  $(BCC32) -P- -c @&&|
+ $(CompOptsAt_circledexe) $(CompInheritOptsAt_circledexe) -o$@ qedit.c
+|
+
+genqst.obj :  genqst.c
+  $(BCC32) -P- -c @&&|
+ $(CompOptsAt_circledexe) $(CompInheritOptsAt_circledexe) -o$@ genqst.c
+|
+
 # Compiler configuration file
 BccW32.cfg : 
    Copy &&|
diff -BbuprN tbamud-3.55/src/Makefile.bcc55 tbamud-3.55+quests/src/Makefile.bcc55
--- tbamud-3.55/src/Makefile.bcc55	2008-01-16 23:21:14.000000000 +0000
+++ tbamud-3.55+quests/src/Makefile.bcc55	2008-01-31 10:00:37.210047000 +0000
@@ -79,7 +79,10 @@ Dep_circledexe = \
    spec_procs.obj\
    spec_assign.obj\
    utils.obj\
-   weather.obj
+   weather.obj\
+   quest.obj\
+   qedit.obj\
+   genqst.obj
 
 circle.exe : $(Dep_circledexe)
   $(TLINK32) @&&|
@@ -120,7 +123,10 @@ spell_parser.obj+
 spec_procs.obj+
 spec_assign.obj+
 utils.obj+
-weather.obj
+weather.obj+
+quest.obj+
+qedit.obj+
+genqst.obj
 $<,$*
 C:\BORLAND\BCC55\LIB\import32.lib+
 C:\BORLAND\BCC55\LIB\cw32i.lib
@@ -306,6 +312,21 @@ weather.obj :  weather.c
  $(CompOptsAt_circledexe) $(CompInheritOptsAt_circledexe) -o$@ weather.c
 |
 
+quest.obj :  quest.c
+  $(BCC32) -P- -c @&&|
+ $(CompOptsAt_circledexe) $(CompInheritOptsAt_circledexe) -o$@ quest.c
+|
+
+qedit.obj :  qedit.c
+  $(BCC32) -P- -c @&&|
+ $(CompOptsAt_circledexe) $(CompInheritOptsAt_circledexe) -o$@ qedit.c
+|
+
+genqst.obj :  genqst.c
+  $(BCC32) -P- -c @&&|
+ $(CompOptsAt_circledexe) $(CompInheritOptsAt_circledexe) -o$@ genqst.c
+|
+
 # Compiler configuration file
 BccW32.cfg : 
    Copy &&|
diff -BbuprN tbamud-3.55/src/Makefile.lcc tbamud-3.55+quests/src/Makefile.lcc
--- tbamud-3.55/src/Makefile.lcc	2008-01-16 23:21:14.000000000 +0000
+++ tbamud-3.55+quests/src/Makefile.lcc	2008-01-31 10:06:53.975672000 +0000
@@ -16,6 +16,9 @@ DISTDIR=c:\circle
 CFLAGS=-c -I$(LCCDIR)\include -DLCC_WIN32
 CC=lcc
 OBJS=\
+	genqst.obj \
+	qedit.obj \
+	quest.obj \
 	weather.obj \
 	utils.obj \
 	spells.obj \
@@ -58,6 +61,52 @@ LIBS=$(LCCDIR)\lib\wsock32.lib
 circle.exe:	$(OBJS)
         lcclnk  -subsystem console -o $(DISTDIR)\bin\circle.exe $(OBJS) $(LIBS)
 
+# Build GENQST.C
+GENQST_C=\
+    $(DISTDIR)\src\sysdep.h\
+    $(DISTDIR)\src\structs.h\
+    $(DISTDIR)\src\utils.h\
+    $(DISTDIR)\src\genolc.h\
+    $(DISTDIR)\src\genzon.h\
+    $(DISTDIR)\src\quest.h\
+    $(DISTDIR)\src\db.h\
+
+genqst.obj: $(GENQST_C) $(DISTDIR)\src\genqst.c
+    $(CC)  $(CFLAGS) $(DISTDIR)\src\genqst.c
+
+# Build QEDIT.C
+QEDIT_C=\
+    $(DISTDIR)\src\sysdep.h\
+    $(DISTDIR)\src\structs.h\
+    $(DISTDIR)\src\utils.h\
+    $(DISTDIR)\src\comm.h\
+    $(DISTDIR)\src\db.h\
+    $(DISTDIR)\src\oasis.h\
+    $(DISTDIR)\src\improved-edit.h\
+    $(DISTDIR)\src\screen.h\
+    $(DISTDIR)\src\genolc.h\
+    $(DISTDIR)\src\genzon.h\
+    $(DISTDIR)\src\interpreter.h\
+    $(DISTDIR)\src\quest.h\
+
+qedit.obj: $(QEDIT_C) $(DISTDIR)\src\qedit.c
+    $(CC)  $(CFLAGS) $(DISTDIR)\src\qedit.c
+
+# Build QUEST.C
+QUEST_C=\
+    $(DISTDIR)\src\sysdep.h\
+    $(DISTDIR)\src\structs.h\
+    $(DISTDIR)\src\utils.h\
+    $(DISTDIR)\src\comm.h\
+    $(DISTDIR)\src\handler.h\
+    $(DISTDIR)\src\interpreter.h\
+    $(DISTDIR)\src\db.h\
+    $(DISTDIR)\src\screen.h\
+    $(DISTDIR)\src\quest.h\
+
+quest.obj: $(QUEST_C) $(DISTDIR)\src\quest.c
+    $(CC)  $(CFLAGS) $(DISTDIR)\src\quest.c
+
 # Build WEATHER.C
 WEATHER_C=\
     $(DISTDIR)\src\sysdep.h\
diff -BbuprN tbamud-3.55/src/Makefile.msvc tbamud-3.55+quests/src/Makefile.msvc
--- tbamud-3.55/src/Makefile.msvc	2008-01-16 23:21:14.000000000 +0000
+++ tbamud-3.55+quests/src/Makefile.msvc	2008-01-31 10:08:32.631922000 +0000
@@ -40,7 +40,7 @@ OBJFILES = comm.obj act.comm.obj act.inf
         castle.obj class.obj config.obj constants.obj db.obj fight.obj graph.obj handler.obj \
         house.obj interpreter.obj limits.obj magic.obj mail.obj mobact.obj modify.obj \
         objsave.obj shop.obj spec_assign.obj spec_procs.obj spell_parser.obj \
-        spells.obj utils.obj weather.obj random.obj players.obj
+        spells.obj utils.obj weather.obj random.obj players.obj quest.obj qedit.obj genqst.obj
 
 default: circle.exe
         $(MAKE) circle.exe
@@ -153,3 +153,12 @@ utils.obj: utils.c conf.h sysdep.h struc
 weather.obj: weather.c conf.h sysdep.h structs.h utils.h comm.h handler.h \
   interpreter.h db.h
 	$(CC) -c $(CFLAGS) weather.c
+quest.obj: quest.c conf.h sysdep.h structs.h utils.h interpreter.h handler.h \
+  comm.h db.h screen.h quest.h
+	$(CC) -c $(CFLAGS) quest.c
+qedit.obj: qedit.c conf.h sysdep.h structs.h utils.h comm.h db.h oasis.h \
+  improved-edit.h screen.h genolc.h genzon.h interpreter.h quest.h
+	$(CC) -c $(CFLAGS) qedit.c
+genqst.obj: genqst.c conf.h sysdep.h structs.h utils.h db.h quest.h \
+  genolc.h genzon.h 
+	$(CC) -c $(CFLAGS) genqst.c
\ No newline at end of file
diff -BbuprN tbamud-3.55/src/Makefile.os2 tbamud-3.55+quests/src/Makefile.os2
--- tbamud-3.55/src/Makefile.os2	2008-01-16 23:21:16.000000000 +0000
+++ tbamud-3.55+quests/src/Makefile.os2	2008-01-31 10:09:20.850672000 +0000
@@ -26,7 +26,7 @@ OBJFILES = comm.o act.comm.o act.informa
         castle.o class.o config.o constants.o db.o fight.o graph.o handler.o \
         house.o interpreter.o limits.o magic.o mail.o mobact.o modify.o \
         objsave.o shop.o spec_assign.o spec_procs.o spell_parser.o \
-        spells.o utils.o weather.o random.o players.o
+        spells.o utils.o weather.o random.o players.o quest.o qedit.o genqst.o
 
 default: .accepted
         $(MAKE) ../bin/circle
@@ -194,3 +194,12 @@ utils.o: utils.c conf.h sysdep.h structs
 weather.o: weather.c conf.h sysdep.h structs.h utils.h comm.h handler.h \
   interpreter.h db.h
         $(CC) -c $(CFLAGS) weather.c
+quest.obj: quest.c conf.h sysdep.h structs.h utils.h interpreter.h handler.h \
+  comm.h db.h screen.h quest.h
+	$(CC) -c $(CFLAGS) quest.c
+qedit.obj: qedit.c conf.h sysdep.h structs.h utils.h comm.h db.h oasis.h \
+  improved-edit.h screen.h genolc.h genzon.h interpreter.h quest.h
+	$(CC) -c $(CFLAGS) qedit.c
+genqst.obj: genqst.c conf.h sysdep.h structs.h utils.h db.h quest.h \
+  genolc.h genzon.h 
+	$(CC) -c $(CFLAGS) genqst.c
\ No newline at end of file
diff -BbuprN tbamud-3.55/src/act.informative.c tbamud-3.55+quests/src/act.informative.c
--- tbamud-3.55/src/act.informative.c	2008-01-16 23:28:12.000000000 +0000
+++ tbamud-3.55+quests/src/act.informative.c	2008-01-31 08:42:49.006922000 +0000
@@ -827,6 +827,16 @@ ACMD(do_score)
     send_to_char(ch, "You need %d exp to reach your next level.\r\n",
 	level_exp(GET_CLASS(ch), GET_LEVEL(ch) + 1) - GET_EXP(ch));
 
+  send_to_char(ch, "You have earned %d quest points.\r\n", GET_QUESTPOINTS(ch));
+  send_to_char(ch, "You have completed %d quest%s, ",
+		    GET_NUM_QUESTS(ch),
+		    GET_NUM_QUESTS(ch) == 1 ? "" : "s");
+  if (GET_QUEST(ch) == NOTHING)
+    send_to_char(ch, "and you are not on a quest at the moment.\r\n");
+  else
+    send_to_char(ch, "and your current quest is %d.\r\n",
+                     GET_QUEST(ch) == NOTHING ? -1 : GET_QUEST(ch));
+
   playing_time = *real_time_passed((time(0) - ch->player.time.logon) +
 				  ch->player.time.played, 0);
   send_to_char(ch, "You have been playing for %d day%s and %d hour%s.\r\n",
diff -BbuprN tbamud-3.55/src/act.item.c tbamud-3.55+quests/src/act.item.c
--- tbamud-3.55/src/act.item.c	2008-01-16 23:21:16.000000000 +0000
+++ tbamud-3.55+quests/src/act.item.c	2008-01-31 08:45:40.663172000 +0000
@@ -20,6 +20,7 @@
 #include "constants.h"
 #include "dg_scripts.h"
 #include "oasis.h"
+#include "quest.h"
 
 /* local functions */
 int can_take_obj(struct char_data *ch, struct obj_data *obj);
@@ -619,6 +620,8 @@ void perform_give(struct char_data *ch, 
   act("You give $p to $N.", FALSE, ch, obj, vict, TO_CHAR);
   act("$n gives you $p.", FALSE, ch, obj, vict, TO_VICT);
   act("$n gives $p to $N.", TRUE, ch, obj, vict, TO_NOTVICT);
+
+  autoquest_trigger_check( ch, vict, obj, AQ_OBJ_RETURN);
 }
 
 /* utility function for give */
diff -BbuprN tbamud-3.55/src/act.other.c tbamud-3.55+quests/src/act.other.c
--- tbamud-3.55/src/act.other.c	2008-01-16 23:21:16.000000000 +0000
+++ tbamud-3.55+quests/src/act.other.c	2008-01-31 08:46:54.663172000 +0000
@@ -23,6 +23,7 @@
 #include "house.h"
 #include "constants.h"
 #include "dg_scripts.h"
+#include "quest.h"
 
 /* extern variables */
 extern struct spell_info_type spell_info[];
@@ -74,6 +75,8 @@ ACMD(do_quit)
   } else {
     act("$n has left the game.", TRUE, ch, 0, 0, TO_ROOM);
     mudlog(NRM, MAX(LVL_IMMORT, GET_INVIS_LEV(ch)), TRUE, "%s has quit the game.", GET_NAME(ch));
+    if (GET_QUEST_TIME(ch) != -1)
+      quest_timeout(ch);
     send_to_char(ch, "Goodbye, friend.. Come back soon!\r\n");
 
     /* We used to check here for duping attempts, but we may as well do it right
diff -BbuprN tbamud-3.55/src/act.wizard.c tbamud-3.55+quests/src/act.wizard.c
--- tbamud-3.55/src/act.wizard.c	2008-01-16 23:28:42.000000000 +0000
+++ tbamud-3.55+quests/src/act.wizard.c	2008-01-31 12:14:04.850672000 +0000
@@ -23,6 +23,7 @@
 #include "oasis.h"
 #include "dg_scripts.h"
 #include "shop.h"
+#include "quest.h"
 
 /* external vars */
 extern FILE *player_fl;
@@ -893,6 +894,12 @@ void do_stat_character(struct char_data 
 
     sprintbitarray(PRF_FLAGS(k), preference_bits, PR_ARRAY_MAX, buf);
     send_to_char(ch, "PRF: %s%s%s\r\n", CCGRN(ch, C_NRM), buf, CCNRM(ch, C_NRM));
+
+    send_to_char(ch, "Quest Points: [%9d] Quests Completed: [%5d]\r\n",
+		    GET_QUESTPOINTS(ch), GET_NUM_QUESTS(ch));
+    if (GET_QUEST(ch) != NOTHING)
+      send_to_char(ch, "Current Quest: [%5d] Time Left: [%5d]\r\n",
+		   GET_QUEST(ch), GET_QUEST_TIME(ch));
   }
 
   if (IS_MOB(k))
@@ -2581,7 +2588,7 @@ ACMD(do_show)
 	"  %5d objects          %5d prototypes\r\n"
 	"  %5d rooms            %5d zones\r\n"
         "  %5d triggers         %5d shops\r\n"
-      	"  %5d large bufs\r\n"
+      	"  %5d large bufs       %5d autoquests\r\n"
 	"  %5d buf switches     %5d overflows\r\n",
 	i, con,
 	top_of_p_table + 1,
@@ -2589,7 +2596,7 @@ ACMD(do_show)
 	k, top_of_objt + 1,
 	top_of_world + 1, top_of_zone_table + 1,
 	top_of_trigt + 1, top_shop + 1,
-	buf_largecount,
+	buf_largecount, total_quests,
 	buf_switches, buf_overflows
 	);
     break;
@@ -2756,12 +2763,13 @@ ACMD(do_show)
    { "weight",		LVL_BUILDER,	BOTH,	NUMBER },
    { "wis", 		LVL_BUILDER, 	BOTH, 	NUMBER },
    { "questpoints",     LVL_GOD,        PC,     NUMBER },
+   { "questhistory",    LVL_GOD,        PC,   NUMBER },
    { "\n", 0, BOTH, MISC }
   };
 
 int perform_set(struct char_data *ch, struct char_data *vict, int mode, char *val_arg)
 {
-  int i, on = 0, off = 0, value = 0;
+  int i, on = 0, off = 0, value = 0, qvnum;
   room_rnum rnum;
   room_vnum rvnum;
 
@@ -3141,6 +3149,23 @@ int perform_set(struct char_data *ch, st
     case 54: /* questpoints */
       GET_QUESTPOINTS(vict) = RANGE(0, 100000000);
       break;
+    case 55: /* questhistory */
+      qvnum = atoi(val_arg);
+      if (real_quest(qvnum) == NOTHING) {
+        send_to_char(ch, "That quest doesn't exist.\r\n");
+        return FALSE;
+      } else {
+        if (is_complete(vict, qvnum)) {
+          remove_completed_quest(vict, qvnum);
+          send_to_char(ch, "Quest %d removed from history for player %s.\r\n",
+			qvnum, GET_NAME(vict));
+        } else {
+          add_completed_quest(vict, qvnum);
+          send_to_char(ch, "Quest %d added to history for player %s.\r\n",
+			qvnum, GET_NAME(vict));
+        }
+        break;
+      }
     default:
       send_to_char(ch, "Can't set that!\r\n");
       return (0);
diff -BbuprN tbamud-3.55/src/comm.c tbamud-3.55+quests/src/comm.c
--- tbamud-3.55/src/comm.c	2008-01-16 23:21:16.000000000 +0000
+++ tbamud-3.55+quests/src/comm.c	2008-01-31 08:59:29.756922000 +0000
@@ -61,6 +61,7 @@
 #include "genolc.h"
 #include "dg_scripts.h"
 #include "dg_event.h"
+#include "quest.h"
 
 #ifdef HAVE_ARPA_TELNET_H
 #include <arpa/telnet.h>
@@ -969,11 +970,12 @@ void heartbeat(int heart_pulse)
   if (!(heart_pulse % PULSE_VIOLENCE))
     perform_violence();
 
-  if (!(heart_pulse % (SECS_PER_MUD_HOUR * PASSES_PER_SEC))) {
+  if (!(heart_pulse % (SECS_PER_MUD_HOUR * PASSES_PER_SEC))) {  /* Tick ! */
     weather_and_time(1);
     check_time_triggers();
     affect_update();
     point_update();
+    check_timed_quests();
   }
 
   if (CONFIG_AUTO_SAVE && !(heart_pulse % PULSE_AUTOSAVE)) {	/* 1 minute */
diff -BbuprN tbamud-3.55/src/constants.c tbamud-3.55+quests/src/constants.c
--- tbamud-3.55/src/constants.c	2008-01-16 23:21:16.000000000 +0000
+++ tbamud-3.55+quests/src/constants.c	2008-01-31 09:00:51.975672000 +0000
@@ -362,6 +362,7 @@ const char *extra_bits[] = {
   "ANTI_THIEF",
   "ANTI_WARRIOR",
   "NO_SELL",
+  "QUEST_ITEM",
   "\n"
 };
 
diff -BbuprN tbamud-3.55/src/db.c tbamud-3.55+quests/src/db.c
--- tbamud-3.55/src/db.c	2008-01-16 23:21:14.000000000 +0000
+++ tbamud-3.55+quests/src/db.c	2008-01-31 12:16:56.694422000 +0000
@@ -25,6 +25,7 @@
 #include "oasis.h"
 #include "dg_scripts.h"
 #include "dg_event.h"
+#include "quest.h"
 
 /*  declarations of most of the 'global' variables */
 struct config_data config_info; /* Game configuration list.	 */
@@ -56,6 +57,9 @@ int dg_owner_purged;            /* For c
 struct shop_data *shop_index;   /* index table for shops         */
 int top_shop = -1;              /* top of shop table             */
 
+struct aq_data *aquest_table;   /* Autoquests table              */
+qst_rnum total_quests = 0;      /* top of autoquest table        */
+
 int no_mail = 0;		/* mail disabled?		 */
 int mini_mud = 0;		/* mini-mud mode?		 */
 int no_rent_check = 0;		/* skip rent check on boot?	 */
@@ -472,6 +476,9 @@ void boot_world(void)
   if (!no_specials) {
     log("Loading shops.");
     index_boot(DB_BOOT_SHP);
+
+    log("Loading quests.");
+    index_boot(DB_BOOT_QST);
   }
 }
 
@@ -582,6 +589,9 @@ void destroy_db(void)
   /* Shops */
   destroy_shops();
 
+  /* Quests */
+  destroy_quests();
+
   /* Zones */
 #define THIS_CMD zone_table[cnt].cmd[itr]
 
@@ -706,6 +716,8 @@ void boot_db(void)
     assign_objects();
     log("   Rooms.");
     assign_rooms();
+    log("   Questmasters.");
+    assign_the_quests();
   }
 
   log("Assigning spell and skill levels.");
@@ -914,6 +926,9 @@ void index_boot(int mode)
   case DB_BOOT_TRG:
     prefix = TRG_PREFIX;
     break;
+  case DB_BOOT_QST:
+    prefix = QST_PREFIX;
+    break;
   default:
     log("SYSERR: Unknown subcommand %d to index_boot!", mode);
     exit(1);
@@ -954,7 +969,7 @@ void index_boot(int mode)
 
   /* Exit if 0 records, unless this is shops */
   if (!rec_count) {
-    if (mode == DB_BOOT_SHP)
+    if (mode == DB_BOOT_SHP || mode == DB_BOOT_QST)
       return;
     log("SYSERR: boot error - 0 records counted in %s/%s.", prefix,
 	index_filename);
@@ -995,6 +1010,11 @@ void index_boot(int mode)
     size[0] = sizeof(struct help_index_element) * rec_count;
     log("   %d entries, %d bytes.", rec_count, size[0]);
     break;
+  case DB_BOOT_QST:
+    CREATE(aquest_table, struct aq_data, rec_count);
+    size[0] = sizeof(struct aq_data) * rec_count;
+    log("   %d entries, %d bytes.", rec_count, size[0]);
+    break;
   }
 
   rewind(db_index);
@@ -1010,6 +1030,7 @@ void index_boot(int mode)
     case DB_BOOT_OBJ:
     case DB_BOOT_MOB:
     case DB_BOOT_TRG:
+    case DB_BOOT_QST:
       discrete_load(db_file, mode, buf2);
       break;
     case DB_BOOT_ZON:
@@ -1040,7 +1061,7 @@ void discrete_load(FILE *fl, int mode, c
   int nr = -1, last;
   char line[READ_SIZE];
 
-  const char *modes[] = {"world", "mob", "obj", "ZON", "SHP", "HLP", "trg"};
+  const char *modes[] = {"world", "mob", "obj", "ZON", "SHP", "HLP", "trg", "qst"};
   /* modes positions correspond to DB_BOOT_xxx in db.h */
 
   for (;;) {
@@ -1083,6 +1104,9 @@ void discrete_load(FILE *fl, int mode, c
 	case DB_BOOT_OBJ:
 	  strlcpy(line, parse_object(fl, nr), sizeof(line));
 	  break;
+	case DB_BOOT_QST:
+	  parse_quest(fl, nr);
+	  break;
 	}
     } else {
       log("SYSERR: Format error in %s file %s near %s #%d", modes[mode],
@@ -2747,6 +2771,8 @@ void free_char(struct char_data *ch)
       free(ch->player_specials->poofin);
     if (ch->player_specials->poofout)
       free(ch->player_specials->poofout);
+    if (ch->player_specials->saved.completed_quests)
+      free(ch->player_specials->saved.completed_quests);
     if (GET_HOST(ch))
       free(GET_HOST(ch));
     if (IS_NPC(ch))
@@ -2996,6 +3022,10 @@ void init_char(struct char_data *ch)
   ch->player.long_descr = NULL;
   ch->player.description = NULL;
 
+  GET_NUM_QUESTS(ch) = 0;
+  ch->player_specials->saved.completed_quests = NULL;
+  GET_QUEST(ch) = -1;
+
   ch->player.time.birth = time(0);
   ch->player.time.logon = time(0);
   ch->player.time.played = 0;
diff -BbuprN tbamud-3.55/src/db.h tbamud-3.55+quests/src/db.h
--- tbamud-3.55/src/db.h	2008-01-16 23:21:14.000000000 +0000
+++ tbamud-3.55+quests/src/db.h	2008-01-31 09:10:29.241297000 +0000
@@ -16,6 +16,7 @@
 #define DB_BOOT_SHP	4
 #define DB_BOOT_HLP	5
 #define DB_BOOT_TRG	6
+#define DB_BOOT_QST 7
 
 #if defined(CIRCLE_MACINTOSH)
 #define LIB_WORLD	":world:"
@@ -76,6 +77,7 @@
 #define SHP_PREFIX	LIB_WORLD"shp"SLASH	/* shop definitions	*/
 #define TRG_PREFIX	LIB_WORLD"trg"SLASH	/* trigger files	*/
 #define HLP_PREFIX      LIB_TEXT"help"SLASH     /* Help files           */
+#define QST_PREFIX      LIB_WORLD"qst"SLASH     /* quest files          */
 
 #define CREDITS_FILE	LIB_TEXT"credits" /* for the 'credits' command	*/
 #define NEWS_FILE	LIB_TEXT"news"	/* for the 'news' command	*/
diff -BbuprN tbamud-3.55/src/dg_variables.c tbamud-3.55+quests/src/dg_variables.c
--- tbamud-3.55/src/dg_variables.c	2008-01-16 23:21:16.000000000 +0000
+++ tbamud-3.55+quests/src/dg_variables.c	2008-01-31 09:14:08.460047000 +0000
@@ -853,7 +853,7 @@ void find_replacement(void *go, struct s
           }
           break;
         case 'q':
-          if (!str_cmp(field, "questpoints")) {
+          if (!str_cmp(field, "questpoints") || !str_cmp(field, "qp") || !str_cmp(field, "qpnts")) {
             if (subfield && *subfield) {
               int addition = atoi(subfield);
               GET_QUESTPOINTS(c) += addition;
diff -BbuprN tbamud-3.55/src/fight.c tbamud-3.55+quests/src/fight.c
--- tbamud-3.55/src/fight.c	2008-01-16 23:21:14.000000000 +0000
+++ tbamud-3.55+quests/src/fight.c	2008-01-31 09:15:53.710047000 +0000
@@ -20,6 +20,7 @@
 #include "screen.h"
 #include "constants.h"
 #include "dg_scripts.h"
+#include "quest.h"
 
 /* Structures */
 struct char_data *combat_list = NULL;	/* head of l-list of fighting chars */
@@ -363,10 +364,18 @@ void raw_kill(struct char_data * ch, str
   } else
     death_cry(ch);
 
+  if (killer)
+    autoquest_trigger_check(killer, ch, NULL, AQ_MOB_KILL);
+
   update_pos(ch);
 
   make_corpse(ch);
   extract_char(ch);
+
+  if (killer) {
+    autoquest_trigger_check(killer, NULL, NULL, AQ_MOB_SAVE);
+    autoquest_trigger_check(killer, NULL, NULL, AQ_ROOM_CLEAR);
+  }
 }
 
 void die(struct char_data * ch, struct char_data * killer)
diff -BbuprN tbamud-3.55/src/genolc.c tbamud-3.55+quests/src/genolc.c
--- tbamud-3.55/src/genolc.c	2008-01-16 23:21:14.000000000 +0000
+++ tbamud-3.55+quests/src/genolc.c	2008-01-31 09:17:34.069422000 +0000
@@ -25,6 +25,7 @@
 #include "dg_olc.h"
 #include "constants.h"
 #include "interpreter.h"
+#include "quest.h"
 
 int save_config( IDXTYPE nowhere );        /* Exported from cedit.c */
 
@@ -43,6 +44,7 @@ struct {
   { SL_WLD, save_rooms, "room" },
   { SL_ZON, save_zone, "zone" },
   { SL_CFG, save_config, "config" },
+  { SL_QST, save_quests, "quest" },
   { SL_ACT, NULL, "social" },
   { SL_HLP, NULL, "help" },
   { -1, NULL, NULL },
diff -BbuprN tbamud-3.55/src/genolc.h tbamud-3.55+quests/src/genolc.h
--- tbamud-3.55/src/genolc.h	2008-01-16 23:21:14.000000000 +0000
+++ tbamud-3.55+quests/src/genolc.h	2008-01-31 09:17:49.678797000 +0000
@@ -36,7 +36,8 @@ extern struct save_list_data *save_list;
 #define SL_WLD	3
 #define SL_ZON	4
 #define SL_CFG	5
-#define SL_MAX  5	
+#define SL_QST  6
+#define SL_MAX  6
 #define SL_ACT SL_MAX + 1 /* must be above MAX */ 
 #define SL_HLP SL_MAX + 2
 
diff -BbuprN tbamud-3.55/src/genqst.c tbamud-3.55+quests/src/genqst.c
--- tbamud-3.55/src/genqst.c	1970-01-01 00:00:00.000000000 +0000
+++ tbamud-3.55+quests/src/genqst.c	2008-01-31 12:32:14.210047000 +0000
@@ -0,0 +1,267 @@
+/* ***********************************************************************
+*    File:   genqst.c                                 Part of CircleMUD  *
+* Version:   2.0 (November 2005) Written for CircleMud CWG / Suntzu      *
+* Purpose:   To provide special quest-related code.                      *
+* Copyright: Kenneth Ray                                                 *
+* Original Version Details:                                              *
+* Copyright 1996 by Harvey Gilpin					 *
+* Copyright 1997-2001 by George Greer (greerga@circlemud.org)		 *
+************************************************************************ */
+
+#include "conf.h"
+#include "sysdep.h"
+#include "structs.h"
+#include "utils.h"
+#include "db.h"
+#include "quest.h"
+#include "genolc.h"
+#include "genzon.h"
+
+void create_world_index(int znum, const char *type);
+
+extern zone_rnum top_of_zone_table;
+
+/*-------------------------------------------------------------------*/
+
+int copy_quest(struct aq_data *to, struct aq_data *from, int free_old_strings)
+{
+  int i;
+  if (free_old_strings)
+    free_quest_strings(to);
+  to->vnum       = from->vnum;
+  to->flags      = from->flags;
+  to->type       = from->type;
+  to->qm         = from->qm;
+  to->target     = from->target;
+  to->prereq     = from->prereq;
+  to->prev_quest = from->prev_quest;
+  to->next_quest = from->next_quest;
+  for (i = 0; i < 7; i++){
+    to->value[i] = from->value[i];
+  }
+  to->gold_reward = from->gold_reward;
+  to->exp_reward  = from->exp_reward;
+  to->obj_reward  = from->obj_reward;
+  to->func        = from->func;
+  return copy_quest_strings(to, from);
+}
+
+int copy_quest_strings(struct aq_data *to, struct aq_data *from)
+{
+  if (from == NULL || to == NULL) {
+    log("SYSERR: GenQST: copy_quest_strings: Null values passed.");
+    return FALSE;
+  }
+  to->name = str_udup(from->name);
+  to->desc = str_udup(from->desc);
+  to->info = str_udup(from->info);
+  to->done = str_udup(from->done);
+  to->quit = str_udup(from->quit);
+  return TRUE;
+}
+
+void free_quest_strings(struct aq_data *quest)
+{
+  if (quest->name)
+    free(quest->name);
+  if (quest->desc)
+    free(quest->desc);
+  if (quest->info)
+    free(quest->info);
+  if (quest->done)
+    free(quest->done);
+  if (quest->quit)
+    free(quest->quit);
+}
+
+void free_quest(struct aq_data *quest)
+{
+  free_quest_strings(quest);
+  free(quest);
+}
+
+/*-------------------------------------------------------------------*/
+
+int add_quest(struct aq_data *nqst)
+{
+  qst_rnum rnum;
+  zone_rnum rznum = real_zone_by_thing(nqst->vnum);
+
+  /* The quest already exists, just update it.  */
+  if ((rnum = real_quest(nqst->vnum)) != NOWHERE) {
+    copy_quest(&aquest_table[rnum], nqst, TRUE);
+  } else {
+    /* increase the number of quest table entries */
+    total_quests++;
+    RECREATE(aquest_table, struct aq_data, total_quests );
+    /* Initialise top quest strings to null */
+    QST_NAME(total_quests - 1) = NULL;
+    QST_DESC(total_quests - 1) = NULL;
+    QST_INFO(total_quests - 1) = NULL;
+    QST_DONE(total_quests - 1) = NULL;
+    QST_QUIT(total_quests - 1) = NULL;
+    /* Now process enties from the top down to see where the new one goes */
+    for (rnum = total_quests - 1; rnum > 0; rnum--) {
+      if (nqst->vnum > QST_NUM(rnum - 1))
+        break; //found the place
+      aquest_table[rnum] = aquest_table[rnum - 1]; //shift quest up one
+    }
+    copy_quest(&aquest_table[rnum], nqst, FALSE);
+  }
+  /* Make sure we assign spec procs to the questmaster */
+  if (mob_index[QST_MASTER(rnum)].func &&
+      mob_index[QST_MASTER(rnum)].func != questmaster)
+    QST_FUNC(rnum) = mob_index[QST_MASTER(rnum)].func;
+  mob_index[QST_MASTER(rnum)].func = questmaster;
+
+  /* And make sure we save the updated quest information to disk */
+  if (rznum != NOWHERE)
+    add_to_save_list(zone_table[rznum].number, SL_QST);
+  else
+    mudlog(BRF, LVL_BUILDER, TRUE,
+           "SYSERR: GenOLC: Cannot determine quest zone.");
+
+  return rnum;
+}
+
+/*-------------------------------------------------------------------*/
+
+int delete_quest(qst_rnum rnum)
+{
+  qst_rnum i;
+  zone_rnum rznum = real_zone_by_thing(QST_NUM(rnum));
+  mob_rnum qm = QST_MASTER(rnum);
+  SPECIAL (*tempfunc);
+  int  quests_remaining = 0;
+
+  if (rnum >= total_quests)
+    return FALSE;
+  log("GenOLC: delete_quest: Deleting quest #%d (%s).",
+       QST_NUM(rnum), QST_NAME(rnum));
+  /* make a note of the quest master's secondary spec proc */
+  tempfunc = QST_FUNC(rnum);
+
+
+  free_quest_strings(&aquest_table[rnum]);
+  for (i = rnum; i < total_quests - 1; i++) {
+    aquest_table[i] = aquest_table[i + 1];
+  }
+  total_quests--;
+  RECREATE(aquest_table, struct aq_data, total_quests);
+
+  if (rznum != NOWHERE)
+     add_to_save_list(zone_table[rznum].number, SL_QST);
+  else
+    mudlog(BRF, LVL_BUILDER, TRUE,
+           "SYSERR: GenOLC: Cannot determine quest zone.");
+  /* does the questmaster mob have any quests left? */
+  if (qm != NOBODY) {
+    for (i = 0; i < total_quests; i++) {
+      if (QST_MASTER(i) == qm)
+        quests_remaining++;
+    }
+    if (quests_remaining == 0)
+      mob_index[qm].func = tempfunc; // point back to original spec proc
+  }
+  return TRUE;
+}
+
+/*-------------------------------------------------------------------*/
+
+int save_quests(zone_rnum zone_num)
+{
+  FILE *sf;
+  char filename[128], oldname[128], quest_flags[MAX_STRING_LENGTH];
+  char quest_desc[MAX_STRING_LENGTH], quest_info[MAX_STRING_LENGTH];
+  char quest_done[MAX_STRING_LENGTH], quest_quit[MAX_STRING_LENGTH];
+  int i, num_quests = 0;
+
+#if CIRCLE_UNSIGNED_INDEX
+  if (zone_num == NOWHERE || zone_num > top_of_zone_table) {
+#else
+  if (zone_num < 0 || zone_num > top_of_zone_table) {
+#endif
+    log("SYSERR: GenOLC: save_quests: Invalid zone number %d passed! (0-%d)",
+         zone_num, top_of_zone_table);
+    return FALSE;
+  }
+
+  log("GenOLC: save_quests: Saving quests in zone #%d (%d-%d).",
+        zone_table[zone_num].number,
+	genolc_zone_bottom(zone_num), zone_table[zone_num].top);
+
+  snprintf(filename, sizeof(filename), "%s/%d.new",
+	QST_PREFIX, zone_table[zone_num].number);
+  if (!(sf = fopen(filename, "w"))) {
+    perror("SYSERR: save_quests");
+    return FALSE;
+  }
+  for (i = genolc_zone_bottom(zone_num); i <= zone_table[zone_num].top; i++) {
+    qst_rnum rnum;
+    if ((rnum = real_quest(i)) != NOTHING) {
+      /* Copy the text strings and strip off trailing newlines. */
+      strncpy(quest_desc, QST_DESC(rnum) ? QST_DESC(rnum) : "undefined",
+              sizeof(quest_desc)-1 );
+      strncpy(quest_info, QST_INFO(rnum) ? QST_INFO(rnum) : "undefined",
+              sizeof(quest_info)-1 );
+      strncpy(quest_done, QST_DONE(rnum) ? QST_DONE(rnum) : "undefined",
+              sizeof(quest_done)-1 );
+      strncpy(quest_quit, QST_QUIT(rnum) ? QST_QUIT(rnum) : "undefined",
+              sizeof(quest_quit)-1 );
+      strip_cr(quest_desc);
+      strip_cr(quest_info);
+      strip_cr(quest_done);
+      strip_cr(quest_quit);
+      /* Save the quest details to the file.  */
+      sprintascii(quest_flags, QST_FLAGS(rnum));
+      fprintf(sf,
+	"#%d\n"
+        "%s%c\n"
+        "%s%c\n"
+        "%s%c\n"
+        "%s%c\n"
+        "%s%c\n"
+        "%d %d %s %d %d %d %d\n"
+        "%d %d %d %d %d %d %d\n"
+        "%d %d %d\n"
+        "S\n",
+        QST_NUM(rnum),
+        QST_NAME(rnum) ? QST_NAME(rnum) : "Untitled", STRING_TERMINATOR,
+        quest_desc, STRING_TERMINATOR,
+	quest_info, STRING_TERMINATOR,
+	quest_done, STRING_TERMINATOR,
+	quest_quit, STRING_TERMINATOR,
+        QST_TYPE(rnum),
+	QST_MASTER(rnum) == NOBODY ? -1 : mob_index[QST_MASTER(rnum)].vnum,
+	quest_flags,
+	QST_TARGET(rnum) == NOTHING ? -1 : QST_TARGET(rnum),
+	QST_PREV(rnum)   == NOTHING ? -1 : QST_PREV(rnum),
+	QST_NEXT(rnum)   == NOTHING ? -1 : QST_NEXT(rnum),
+	QST_PREREQ(rnum) == NOTHING ? -1 : QST_PREREQ(rnum),
+        QST_POINTS(rnum), QST_PENALTY(rnum), QST_MINLEVEL(rnum),
+        QST_MAXLEVEL(rnum), QST_TIME(rnum),
+	QST_RETURNMOB(rnum) == NOBODY ? -1 : QST_RETURNMOB(rnum),
+	QST_QUANTITY(rnum), QST_GOLD(rnum), QST_EXP(rnum), QST_OBJ(rnum)
+      );
+      num_quests++;
+    }
+  }
+  /* Write the final line and close it.  */
+  fprintf(sf, "$~\n");
+  fclose(sf);
+
+  /* Old file we're replacing. */
+  snprintf(oldname, sizeof(oldname), "%s/%d.qst",
+           QST_PREFIX, zone_table[zone_num].number);
+  remove(oldname);
+  rename(filename, oldname);
+
+  /* Do we need to update the index file? */
+  if (num_quests > 0)
+    create_world_index(zone_table[zone_num].number, "qst");
+
+  if (in_save_list(zone_table[zone_num].number, SL_QST))
+    remove_from_save_list(zone_table[zone_num].number, SL_QST);
+  return TRUE;
+}
+
